import { browser, ExpectedConditions as ec /* , promise */ } from 'protractor';
import { NavBarPage, SignInPage } from '../../page-objects/jhi-page-objects';

import {
  WatchListEntryComponentsPage,
  /* WatchListEntryDeleteDialog, */
  WatchListEntryUpdatePage,
} from './watch-list-entry.page-object';

const expect = chai.expect;

describe('WatchListEntry e2e test', () => {
  let navBarPage: NavBarPage;
  let signInPage: SignInPage;
  let watchListEntryComponentsPage: WatchListEntryComponentsPage;
  let watchListEntryUpdatePage: WatchListEntryUpdatePage;
  /* let watchListEntryDeleteDialog: WatchListEntryDeleteDialog; */

  before(async () => {
    await browser.get('/');
    navBarPage = new NavBarPage();
    signInPage = await navBarPage.getSignInPage();
    signInPage.autoSignInUsing('admin', 'search@admin');
    await browser.wait(ec.visibilityOf(navBarPage.entityMenu), 5000);
    await navBarPage.clickOnEntityMenu();
  });

  it('should load WatchListEntries', async () => {
    await navBarPage.goToEntity('watch-list-entry');
    watchListEntryComponentsPage = new WatchListEntryComponentsPage();
    await browser.wait(ec.visibilityOf(watchListEntryComponentsPage.title), 5000);
    expect(await watchListEntryComponentsPage.getTitle()).to.eq('gitsearchApp.watchListEntry.home.title');
    await browser.wait(
      ec.or(ec.visibilityOf(watchListEntryComponentsPage.entities), ec.visibilityOf(watchListEntryComponentsPage.noResult)),
      1000
    );
  });

  it('should load create WatchListEntry page', async () => {
    await watchListEntryComponentsPage.clickOnCreateButton();
    watchListEntryUpdatePage = new WatchListEntryUpdatePage();
    expect(await watchListEntryUpdatePage.getPageTitle()).to.eq('gitsearchApp.watchListEntry.home.createOrEditLabel');
    await watchListEntryUpdatePage.cancel();
  });

  /* it('should create and save WatchListEntries', async () => {
        const nbButtonsBeforeCreate = await watchListEntryComponentsPage.countDeleteButtons();

        await watchListEntryComponentsPage.clickOnCreateButton();

        await promise.all([
            watchListEntryUpdatePage.setExerciseIdInput('exerciseId'),
            watchListEntryUpdatePage.setExerciseNameInput('exerciseName'),
            watchListEntryUpdatePage.watchlistIdSelectLastOption(),
        ]);

        expect(await watchListEntryUpdatePage.getExerciseIdInput()).to.eq('exerciseId', 'Expected ExerciseId value to be equals to exerciseId');
        expect(await watchListEntryUpdatePage.getExerciseNameInput()).to.eq('exerciseName', 'Expected ExerciseName value to be equals to exerciseName');

        await watchListEntryUpdatePage.save();
        expect(await watchListEntryUpdatePage.getSaveButton().isPresent(), 'Expected save button disappear').to.be.false;

        expect(await watchListEntryComponentsPage.countDeleteButtons()).to.eq(nbButtonsBeforeCreate + 1, 'Expected one more entry in the table');
    }); */

  /* it('should delete last WatchListEntry', async () => {
        const nbButtonsBeforeDelete = await watchListEntryComponentsPage.countDeleteButtons();
        await watchListEntryComponentsPage.clickOnLastDeleteButton();

        watchListEntryDeleteDialog = new WatchListEntryDeleteDialog();
        expect(await watchListEntryDeleteDialog.getDialogTitle())
            .to.eq('gitsearchApp.watchListEntry.delete.question');
        await watchListEntryDeleteDialog.clickOnConfirmButton();

        expect(await watchListEntryComponentsPage.countDeleteButtons()).to.eq(nbButtonsBeforeDelete - 1);
    }); */

  after(async () => {
    await navBarPage.autoSignOut();
  });
});
